<?php

namespace App\Services\ThirdPlatform;

use App\Repositories\Contracts\ThirdApiPlatformRepository;
use App\Support\Traits\Helpers;
use Illuminate\Support\Str;

class ThirdPlatformService extends PlatformAbstractService
{
    use Helpers;

    public function __construct()
    {
        parent::__construct(app(ThirdApiPlatformRepository::class));
    }

    public function checkPlatformToken($platformName)
    {
        $this->setPlatformName($platformName);
        $platform = $this->getPlatformInfo('platform_token');
        return $platform ? $platform : [];
    }

    public function checkUrlFrom($url)
    {
        $platformInfo = $this->getPlatformInfo();
        if(!$platformInfo){
            return false;
        }
        if($platformInfo['platform_type'] == 'self'){
            $domain = substr($url, 7);
            if(!Str::contains(strtolower((string) $platformInfo['platform_url']), $domain)){
                return false;
            }
        }
        return true;
    }

    public function createPlatformToken($platformName)
    {
        $this->setPlatformName($platformName);
        $token = $this->getPlatformInfo('platform_token');
        if($token){
            $jwtToken = $this->generateToken($token);
            return $jwtToken;
        }
        return null;
    }
}

